org.apache.commons.math3.ode

## Interface FirstOrderIntegrator

- All Superinterfaces:
    ODEIntegrator
  All Known Implementing Classes:
    AbstractIntegrator, AdamsBashforthIntegrator, AdamsIntegrator, AdamsMoultonIntegrator, AdaptiveStepsizeIntegrator, ClassicalRungeKuttaIntegrator, DormandPrince54Integrator, DormandPrince853Integrator, EmbeddedRungeKuttaIntegrator, EulerIntegrator, GillIntegrator, GraggBulirschStoerIntegrator, HighamHall54Integrator, MidpointIntegrator, MultistepIntegrator, RungeKuttaIntegrator, ThreeEighthesIntegrator

      public interface FirstOrderIntegrator
      extends ODEIntegrator

  This interface represents a first order integrator for differential equations.

  The classes which are devoted to solve first order differential equations should implement this interface. The problems which can be handled should implement the `FirstOrderDifferentialEquations` interface.

  Since:
    1.2
  Version:
    $Id: FirstOrderIntegrator.java 1416643 2012-12-03 19:37:14Z tn $
  See Also:
    `FirstOrderDifferentialEquations`, `StepHandler`, `EventHandler`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `integrate(FirstOrderDifferentialEquations equations, double t0, double[] y0, double t, double[] y)` Integrate the differential equations up to the given time.

    - ### Methods inherited from interface org.apache.commons.math3.ode.ODEIntegrator

      `addEventHandler, addEventHandler, addStepHandler, clearEventHandlers, clearStepHandlers, getCurrentSignedStepsize, getCurrentStepStart, getEvaluations, getEventHandlers, getMaxEvaluations, getName, getStepHandlers, setMaxEvaluations`

- - ### Method Detail

    - #### integrate

          double integrate(FirstOrderDifferentialEquations equations,
                         double t0,
                         double[] y0,
                         double t,
                         double[] y)
                           throws DimensionMismatchException,
                                  NumberIsTooSmallException,
                                  MaxCountExceededException,
                                  NoBracketingException

      Integrate the differential equations up to the given time.

      This method solves an Initial Value Problem (IVP).

      Since this method stores some internal state variables made available in its public interface during integration (`ODEIntegrator.getCurrentSignedStepsize()`), it is not thread-safe.

      Parameters:
        `equations` - differential equations to integrate
        `t0` - initial time
        `y0` - initial value of the state vector at t0
        `t` - target time for the integration (can be set to a value smaller than `t0` for backward integration)
        `y` - placeholder where to put the state vector at each successful step (and hence at the end of integration), can be the same object as y0
      Returns:
        stop time, will be the same as target time if integration reached its target, but may be different if some `EventHandler` stops it at some point.
      Throws:
        `DimensionMismatchException` - if arrays dimension do not match equations settings
        `NumberIsTooSmallException` - if integration step is too small
        `MaxCountExceededException` - if the number of functions evaluations is exceeded
        `NoBracketingException` - if the location of an event cannot be bracketed

Copyright (c) 2003-2013 Apache Software Foundation